#ifndef APPLICATION_H
#define APPLICATION_H

#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Audio/Music.hpp>
#include <SFML/System/Clock.hpp>
#include <SFML/Graphics/Text.hpp>
#include <SFML/Graphics/Font.hpp>
#include <SFML/Graphics/RectangleShape.hpp>

#include <stack>

#include "note.h"

class Application
{
public:
    Application();
    void run();
    void update();
    void draw();

private:
    sf::RenderWindow game_window;
    sf::Music music;
    sf::RectangleShape pulse_mask;
    sf::RectangleShape pulse_mask_green;

    std::stack<Note> timeline;
    sf::Int64 time_since_last_tick;
    sf::Int64 last_stamp;
    sf::Font font;
    sf::Font font2;
    sf::Text text;
    sf::Text grade;
};

#endif // APPLICATION_H
